package {

	import mx.core.Application;
	
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.objects.primitives.Sphere;

	import flash.display.*;
	import org.papervision3d.scenes.*;
	import org.papervision3d.objects.*;
	import org.papervision3d.cameras.*;
	import org.papervision3d.materials.*;

	[SWF(width=640, height=480, backgroundColor=0x808080, frameRate=30)]
	
	public class SimpleCube extends PV3DARApp {
		
		private var _plane:Plane;
		private var _cube:Cube;

		private var normalImage:DisplayObject3D;
		private var ballImage:DisplayObject3D;

		public function SimpleCube() {
			// カメラ補正ファイルとパターン定義ファイルのファイル名を渡して初期化。
			this.init('Data/camera_para.dat', 'Data/flarlogo.pat');
		}
		
		protected override function onInit():void {
			super.onInit(); // 必ず呼ぶ
		}

		// 画像を平面としてロードする
		public function loadImageNormal( data:Bitmap ):void {

			if (!this._webcam) {
				return;
			}

			// データが PNG で透過があれば、反映されます
			var material:BitmapMaterial = new BitmapMaterial( data.bitmapData );
			material.doubleSided = true;
			material.smooth = true;

			// Planeオブジェクト生成
			// 1辺の長さ,1辺の長さ,面の分割数,面の分割数
			normalImage = new Plane( material, 50, 50, 4, 4 );
			normalImage.z = -20;	// マーカーの上
			normalImage.x = 60;	// マーカーの右
			this._baseNode.addChild( normalImage );

		}

		// 画像を球面としてロードする
		public function loadImageBall( data:Bitmap ):void {

			// データが PNG で透過があれば、反映されます
			var material:BitmapMaterial = new BitmapMaterial( data.bitmapData );
			material.smooth = true;

			//Sphereオブジェクト生成
			// 半径,W:面の分割数,H:面の分割数
			ballImage = new Sphere( material, 40, 16, 12 );
			ballImage.z = -10;	// マーカーの上
			this._baseNode.addChild( ballImage );

		}

		// 画像を球面としてロードする
		public function loadMqo( data:DisplayObject3D ):void {

			this._baseNode.addChild( data );

		}

	}
}